var oe = Object.defineProperty;
var ae = (t, e, r) => e in t ? oe(t, e, { enumerable: !0, configurable: !0, writable: !0, value: r }) : t[e] = r;
var A = (t, e, r) => (ae(t, typeof e != "symbol" ? e + "" : e, r), r), k = (t, e, r) => {
  if (!e.has(t))
    throw TypeError("Cannot " + r);
};
var h = (t, e, r) => (k(t, e, "read from private field"), r ? r.call(t) : e.get(t)), S = (t, e, r) => {
  if (e.has(t))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(t) : e.set(t, r);
}, M = (t, e, r, n) => (k(t, e, "write to private field"), n ? n.call(t, r) : e.set(t, r), r);
function te(t) {
  return t && t.__esModule && Object.prototype.hasOwnProperty.call(t, "default") ? t.default : t;
}
function ie(t) {
  if (t.length >= 255)
    throw new TypeError("Alphabet too long");
  for (var e = new Uint8Array(256), r = 0; r < e.length; r++)
    e[r] = 255;
  for (var n = 0; n < t.length; n++) {
    var u = t.charAt(n), v = u.charCodeAt(0);
    if (e[v] !== 255)
      throw new TypeError(u + " is ambiguous");
    e[v] = n;
  }
  var c = t.length, U = t.charAt(0), B = Math.log(c) / Math.log(256), D = Math.log(256) / Math.log(c);
  function q(i) {
    if (i instanceof Uint8Array || (ArrayBuffer.isView(i) ? i = new Uint8Array(i.buffer, i.byteOffset, i.byteLength) : Array.isArray(i) && (i = Uint8Array.from(i))), !(i instanceof Uint8Array))
      throw new TypeError("Expected Uint8Array");
    if (i.length === 0)
      return "";
    for (var a = 0, s = 0, g = 0, f = i.length; g !== f && i[g] === 0; )
      g++, a++;
    for (var l = (f - g) * D + 1 >>> 0, d = new Uint8Array(l); g !== f; ) {
      for (var T = i[g], E = 0, w = l - 1; (T !== 0 || E < s) && w !== -1; w--, E++)
        T += 256 * d[w] >>> 0, d[w] = T % c >>> 0, T = T / c >>> 0;
      if (T !== 0)
        throw new Error("Non-zero carry");
      s = E, g++;
    }
    for (var o = l - s; o !== l && d[o] === 0; )
      o++;
    for (var y = U.repeat(a); o < l; ++o)
      y += t.charAt(d[o]);
    return y;
  }
  function x(i) {
    if (typeof i != "string")
      throw new TypeError("Expected String");
    if (i.length === 0)
      return new Uint8Array();
    for (var a = 0, s = 0, g = 0; i[a] === U; )
      s++, a++;
    for (var f = (i.length - a) * B + 1 >>> 0, l = new Uint8Array(f); i[a]; ) {
      var d = e[i.charCodeAt(a)];
      if (d === 255)
        return;
      for (var T = 0, E = f - 1; (d !== 0 || T < g) && E !== -1; E--, T++)
        d += c * l[E] >>> 0, l[E] = d % 256 >>> 0, d = d / 256 >>> 0;
      if (d !== 0)
        throw new Error("Non-zero carry");
      g = T, a++;
    }
    for (var w = f - g; w !== f && l[w] === 0; )
      w++;
    for (var o = new Uint8Array(s + (f - w)), y = s; w !== f; )
      o[y++] = l[w++];
    return o;
  }
  function p(i) {
    var a = x(i);
    if (a)
      return a;
    throw new Error("Non-base" + c + " character");
  }
  return {
    encode: q,
    decodeUnsafe: x,
    decode: p
  };
}
var fe = ie;
const he = /* @__PURE__ */ te(fe);
var re = {};
(function(t) {
  (function(e) {
    e([], function() {
      var r = -1, n = -2, u = -3, v = -4, c = -5, U = function(a, s) {
        s = s || {};
        var g = s.verbose || !1;
        g && console.log("Normalize the JSON Object"), a = typeof a == "string" ? this.JSON.parse(a) : a, g && console.log("Creating a empty dictionary");
        var f = {
          strings: [],
          integers: [],
          floats: []
        };
        g && console.log("Creating the AST");
        var l = function w(o) {
          g && console.log("Calling recursiveAstBuilder with " + this.JSON.stringify(o));
          var y = typeof o;
          if (o === null)
            return {
              type: "null",
              index: u
            };
          if (typeof o > "u")
            return {
              type: "undefined",
              index: c
            };
          if (o instanceof Array) {
            var _ = ["@"];
            for (var O in o)
              o.hasOwnProperty(O) && _.push(w(o[O]));
            return _;
          }
          if (y === "object") {
            var _ = ["$"];
            for (var R in o)
              o.hasOwnProperty(R) && (_.push(w(R)), _.push(w(o[R])));
            return _;
          }
          if (o === "")
            return {
              type: "empty",
              index: v
            };
          if (y === "string") {
            var P = i.call(f.strings, o);
            return P == -1 && (f.strings.push(D(o)), P = f.strings.length - 1), {
              type: "strings",
              index: P
            };
          }
          if (y === "number" && o % 1 === 0) {
            var P = i.call(f.integers, o);
            return P == -1 && (f.integers.push(x(o)), P = f.integers.length - 1), {
              type: "integers",
              index: P
            };
          }
          if (y === "number") {
            var P = i.call(f.floats, o);
            return P == -1 && (f.floats.push(o), P = f.floats.length - 1), {
              type: "floats",
              index: P
            };
          }
          if (y === "boolean")
            return {
              type: "boolean",
              index: o ? r : n
            };
          throw new Error("Unexpected argument of type " + typeof o);
        }(a), d = f.strings.length, T = f.integers.length;
        f.floats.length, g && console.log("Parsing the dictionary");
        var E = f.strings.join("|");
        return E += "^" + f.integers.join("|"), E += "^" + f.floats.join("|"), g && console.log("Parsing the structure"), E += "^" + function w(o) {
          if (g && console.log("Calling a recursiveParser with " + this.JSON.stringify(o)), o instanceof Array) {
            var y = o.shift();
            for (var _ in o)
              o.hasOwnProperty(_) && (y += w(o[_]) + "|");
            return (y[y.length - 1] === "|" ? y.slice(0, -1) : y) + "]";
          }
          var O = o.type, R = o.index;
          if (O === "strings")
            return x(R);
          if (O === "integers")
            return x(d + R);
          if (O === "floats")
            return x(d + T + R);
          if (O === "boolean")
            return o.index;
          if (O === "null")
            return u;
          if (O === "undefined")
            return c;
          if (O === "empty")
            return v;
          throw new TypeError("The item is alien!");
        }(l), g && console.log("Ending parser"), s.debug ? {
          dictionary: f,
          ast: l,
          packed: E
        } : E;
      }, B = function(a, s) {
        s = s || {};
        var g = a.split("^");
        s.verbose && console.log("Building dictionary");
        var f = [], l = g[0];
        if (l !== "") {
          l = l.split("|"), s.verbose && console.log("Parse the strings dictionary");
          for (var d = 0, T = l.length; d < T; d++)
            f.push(q(l[d]));
        }
        if (l = g[1], l !== "") {
          l = l.split("|"), s.verbose && console.log("Parse the integers dictionary");
          for (var d = 0, T = l.length; d < T; d++)
            f.push(p(l[d]));
        }
        if (l = g[2], l !== "") {
          l = l.split("|"), s.verbose && console.log("Parse the floats dictionary");
          for (var d = 0, T = l.length; d < T; d++)
            f.push(parseFloat(l[d]));
        }
        l = null, s.verbose && console.log("Tokenizing the structure");
        for (var E = "", w = [], o = g[3].length, d = 0; d < o; d++) {
          var y = g[3].charAt(d);
          y === "|" || y === "$" || y === "@" || y === "]" ? (E && (w.push(p(E)), E = ""), y !== "|" && w.push(y)) : E += y;
        }
        var _ = w.length, O = 0;
        return s.verbose && console.log("Starting recursive parser"), function R() {
          var P = w[O++];
          if (s.verbose && console.log("Reading collection type " + (P === "$" ? "object" : "Array")), P === "@") {
            for (var b = []; O < _; O++) {
              var N = w[O];
              if (s.verbose && console.log("Read " + N + " symbol"), N === "]")
                return b;
              if (N === "@" || N === "$")
                b.push(R());
              else
                switch (N) {
                  case r:
                    b.push(!0);
                    break;
                  case n:
                    b.push(!1);
                    break;
                  case u:
                    b.push(null);
                    break;
                  case c:
                    b.push(void 0);
                    break;
                  case v:
                    b.push("");
                    break;
                  default:
                    b.push(f[N]);
                }
            }
            return s.verbose && console.log("Parsed " + this.JSON.stringify(b)), b;
          }
          if (P === "$") {
            for (var b = {}; O < _; O++) {
              var C = w[O];
              if (C === "]")
                return b;
              C === v ? C = "" : C = f[C];
              var N = w[++O];
              if (N === "@" || N === "$")
                b[C] = R();
              else
                switch (N) {
                  case r:
                    b[C] = !0;
                    break;
                  case n:
                    b[C] = !1;
                    break;
                  case u:
                    b[C] = null;
                    break;
                  case c:
                    b[C] = void 0;
                    break;
                  case v:
                    b[C] = "";
                    break;
                  default:
                    b[C] = f[N];
                }
            }
            return s.verbose && console.log("Parsed " + this.JSON.stringify(b)), b;
          }
          throw new TypeError("Bad token " + P + " isn't a type");
        }();
      }, D = function(a) {
        return typeof a != "string" ? a : a.replace(/[\+ \|\^\%]/g, function(s) {
          return {
            " ": "+",
            "+": "%2B",
            "|": "%7C",
            "^": "%5E",
            "%": "%25"
          }[s];
        });
      }, q = function(a) {
        return typeof a != "string" ? a : a.replace(/\+|%2B|%7C|%5E|%25/g, function(s) {
          return {
            "+": " ",
            "%2B": "+",
            "%7C": "|",
            "%5E": "^",
            "%25": "%"
          }[s];
        });
      }, x = function(a) {
        return Number.prototype.toString.call(a, 36).toUpperCase();
      }, p = function(a) {
        return parseInt(a, 36);
      }, i = Array.prototype.indexOf || function(a, s) {
        for (var g = s || 0, f = this.length; g < f; g++)
          if (this[g] === a)
            return g;
        return -1;
      };
      return {
        JSON,
        pack: U,
        unpack: B
      };
    });
  })(function(e, r) {
    var n = r();
    for (var u in n)
      t[u] = n[u];
  });
})(re);
const ee = /* @__PURE__ */ te(re);
var J, z, j, I, L, H, K, V, Y;
class X {
  constructor(e, r, n, u, v) {
    A(this, "code", 0);
    A(this, "message", "操作成功");
    A(this, "data", null);
    A(this, "url", "");
    A(this, "res", "");
    // static [Symbol.hasInstance](self) { return self?.IS_ECHO_MSG !== undefined }
    S(this, J, null);
    // 判断返回 Response 对象, 还是 Response 中的 data
    S(this, z, !0);
    // 判罚是否已经给出错误提示
    S(this, j, !0);
    S(this, I, {
      get: (e, r) => h(this, L).call(this, r),
      ownKeys: () => Object.keys(h(this, I).getPrototypeOf() || {}),
      getPrototypeOf: () => h(this, z) ? this : this.data,
      getOwnPropertyDescriptor: () => ({
        configurable: !0,
        enumerable: !0,
        writable: !0,
        value: h(this, I).getPrototypeOf()
      })
    });
    S(this, L, (e) => e === "$toast" ? h(this, K) : e === "msg" ? h(this, H) : e === "then" || e === "resp" ? (M(this, j, !0), M(this, z, e === "resp"), h(this, V)) : e === "catch" ? h(this, Y) : e === "IS_ECHO_MSG" ? h(this, j) : Reflect.get(this, e));
    S(this, H, (e = (n) => n, r = !1) => (h(this, K).call(this), M(this, z, r), Promise.resolve(e == null ? void 0 : e(h(this, I).getPrototypeOf()))));
    S(this, K, () => {
      h(this, j) && (M(this, j, !1), we.onToast(this.code, this.message));
    });
    S(this, V, (e) => [0, 1].includes(this.code) ? Promise.resolve(e == null ? void 0 : e(h(this, I).getPrototypeOf())) : Promise.reject(h(this, J)));
    S(this, Y, (e) => Promise.resolve(e(h(this, J))));
    return this.code = e, this.message = r, this.data = n, this.url = u, this.res = v, M(this, J, new Proxy(this, h(this, I)));
  }
}
J = new WeakMap(), z = new WeakMap(), j = new WeakMap(), I = new WeakMap(), L = new WeakMap(), H = new WeakMap(), K = new WeakMap(), V = new WeakMap(), Y = new WeakMap();
const W = (t, e, r, n = "/", u = "") => new X(t, e, r, n, u);
var ne = [
  "utf8",
  "utf-8",
  "unicode-1-1-utf-8"
];
function le(t) {
  if (ne.indexOf(t) < 0 && typeof t < "u" && t != null)
    throw new RangeError("Invalid encoding type. Only utf-8 is supported");
  this.encoding = "utf-8", this.encode = function(e) {
    if (typeof e != "string")
      throw new TypeError("passed argument must be of tye string");
    var r = unescape(encodeURIComponent(e)), n = new Uint8Array(r.length);
    const u = r.split("");
    for (let v = 0; v < u.length; v++)
      n[v] = u[v].charCodeAt(0);
    return n;
  };
}
function ue(t) {
  if (ne.indexOf(t) < 0 && typeof t < "u" && t != null)
    throw new RangeError("Invalid encoding type. Only utf-8 is supported");
  this.encoding = "utf-8", this.decode = function(e, r) {
    if (typeof e > "u")
      return "";
    var n = typeof r < "u" && n in r ? r.stream : !1;
    if (typeof n != "boolean")
      throw new TypeError("stream option must be boolean");
    if (ArrayBuffer.isView(e)) {
      var u = new Uint8Array(e.buffer, e.byteOffset, e.byteLength), v = new Array(u.length);
      for (let c = 0; c < u.length; c++)
        v[c] = String.fromCharCode(u[c]);
      return decodeURIComponent(escape(v.join("")));
    } else
      throw new TypeError("passed argument must be an array buffer view");
  };
}
var se = {
  TextEncoder: le,
  TextDecoder: ue
};
const ce = new se.TextEncoder("utf8"), ge = new se.TextDecoder("utf8"), de = (t) => {
  let e = 5381;
  for (let r = 0; r < t.length; r++)
    e = e * 33 ^ t.charCodeAt(r);
  return (e >>> 0).toString(16);
}, be = (t, e) => t.replace(new RegExp(`^${e}+|${e}+$`, "g"), ""), pe = (t) => ce.encode(t || ""), ve = (t) => ge.decode(new DataView(t), {});
var F, G, Q, m, $;
class Z {
  constructor(e, r, n = ({}) => Promise.reject({ code: -1, msg: "请初始化HTTP请求方法主体" })) {
    S(this, F, void 0);
    S(this, G, void 0);
    S(this, Q, void 0);
    S(this, m, {
      "#": /* @__PURE__ */ new Map(),
      // 系统缓存
      $: /* @__PURE__ */ new Map()
      // 普通缓存
    });
    S(this, $, /* @__PURE__ */ new Map());
    A(this, "request", ({ url: e = "/", method: r = "GET", ...n }, u = !1) => {
      var x;
      const v = r.toUpperCase(), c = de(JSON.stringify([e, v, n])), U = (x = e == null ? void 0 : e.includes) != null && x.call(e, "/_/") ? "#" : "$", { promise: B, resolve: D, reject: q } = Promise.withResolvers();
      return h(this, m)[U].has(c) ? (console.log("缓存命中", e), D(h(this, m)[U].get(c))) : h(this, $).has(c) ? h(this, $).get(c).push([D, q]) : (h(this, $).set(c, [[D, q]]), h(this, F).call(this, { url: e, method: v, ...n }).then((p) => {
        if (![0, 1].includes(p.code))
          throw W(p.code, p.msg, p.data, e, p == null ? void 0 : p.res);
        return [p.code, p.msg, p.data, e, p == null ? void 0 : p.res];
      }).then((p) => ((U == "#" || u && v === "GET") && h(this, m)[U].set(c, p), p)).then((p) => h(this, $).get(c).forEach((i, a, s) => {
        i && i[0](p), delete s[a];
      })).catch((p) => {
        h(this, m)[U].delete(c), h(this, $).get(c).forEach((i, a, s) => {
          i && i[1](p instanceof X ? p : W(-1, p, null, e)), delete s[a];
        });
      }).finally(() => {
        console.log(1111, h(this, $).get(c)), h(this, $).delete(c);
      })), new Proxy(B, {
        get: (p, i) => (...a) => p.then((s) => W(...s)[i](...a)).catch((s) => {
          if (!s instanceof X)
            throw s;
          return typeof s[i] == "function" ? s[i](...a) : s[i];
        })
      });
    });
    A(this, "get", (e, r = {}) => this.request({ url: e, method: "GET", params: r }));
    A(this, "post", (e, r = {}, n = {}) => this.request({ url: e, method: "POST", data: r, params: n }));
    A(this, "put", (e, r = {}, n = {}) => this.request({ url: e, method: "PUT", data: r, params: n }));
    A(this, "del", (e, r = {}, n = {}) => this.request({ url: e, method: "DELETE", data: r, params: n }));
    A(this, "download", (e, r) => {
    });
    A(this, "cache", (e, r = {}) => this.request({ url: e, method: "GET", params: r }, !0));
    A(this, "list", (e, r = {}) => this.get(`/api/${e}/${this.encode(r)}`));
    A(this, "getAppInfo", () => {
    });
    A(this, "refreshCache", (e = !1) => {
      e && h(this, m)["#"].clear(), h(this, m).$.clear();
    });
    A(this, "decode", (e = "", r = {}) => {
      if (e === void 0 || e === "" || e === null)
        return r;
      try {
        const n = h(this, G).decode(e).buffer;
        return ee.unpack(ve(n));
      } catch {
        return console.warn("core.decode", e), r;
      }
    });
    A(this, "encode", (e = {}) => {
      const r = JSON.stringify(e, (n, u) => u === void 0 ? null : u);
      return h(this, G).encode(pe(ee.pack(r)));
    });
    M(this, Q, e), M(this, F, n), M(this, G, he(r));
  }
}
F = new WeakMap(), G = new WeakMap(), Q = new WeakMap(), m = new WeakMap(), $ = new WeakMap();
const we = Z;
Z.onUnhandledRejection = (t) => {
  var e, r, n, u, v, c;
  t != null && t.IS_ECHO_MSG ? ((e = t == null ? void 0 : t.$toast) == null || e.call(t), (r = t == null ? void 0 : t.preventDefault) == null || r.call(t)) : (n = t.reason) != null && n.IS_ECHO_MSG && ((v = (u = t.reason) == null ? void 0 : u.$toast) == null || v.call(u), (c = t == null ? void 0 : t.preventDefault) == null || c.call(t));
};
Z.onToast = (t, e) => [0, 1].includes(t) ? console.log(e) : console.warn(e);
export {
  we as default,
  de as signature,
  pe as str2uint8array,
  be as trim,
  ve as uint8array2str
};
